program Portal;

uses
  Windows,
  SysUtils,
  Classes,
  GGraphic,
  RenD3D,
  RenOGL,
  GFonts,
  WinUtils,
  Objs3D,
  Textures,
  Fonts,
  Colors,
  Points,
  GScene,
  Faces,
  Sectors,
  Walls,
  Types3D,
  PortalEngine,
  PortalRoot,
  GfxTypes,
  Utils3D,
  Messages,
  DemoTools,
  GPortal,
  Lights,
  GeoObjs,
  IniFiles,
  ImgJPG,

  DynLights;

{$R *.res}

var

  Font:TFont;
  F:TFace;
  P:TPortalEngine;
  S:TSector;
  Speed:LongInt=100;
  P00,P01:TFacePoint;
  DL:TDynamicLight;
  Sign:single=-1;
  Wrf:boolean=false;
  Divs:LongInt=1024 div 4;
  Fire:TGeoQuad;
  FireH:TBase3DObj;
  Rot:single=0;
  OldP:TPoint3S;
  Floor:array[0..7]of TFacePoint;
  INI:TInifile;

procedure OnRun;
begin
 Graphic.Draw;
end;

procedure RunTest;
var
    P1,P2,P3,P4:TFacePoint;
    W:TWall;
    
    Ceil:array[0..7]of TFacePoint;
    I:LongInt;

begin
 if F=nil then
  begin
   F:=TFace.Create;
   F.Points[0]:=TFacePoint.Create(-100,0,0,$FFAAAAAA);
   F.Points[1]:=TFacePoint.Create(0,0,100,$FFAAAAAA);
   F.Points[2]:=TFacePoint.Create(100,0,0);
   F.Normal:=Utils3D.NormalizePoint(Point3S(100,100,100));
   F.Texture:=TextureMgr.GetTexture('Wall.jpg');
   F.Coords[0]:=Coord(0,0);
   F.Coords[1]:=Coord(0,0.4);
   F.Coords[2]:=Coord(1,0);

   S:=GPortal.Portal.AddSector('Demo 01');


   P1:=P.AddPoint(TFacePoint.Create(0,0,0,$FFAAAAAA));
   P2:=P.AddPoint(TFacePoint.Create(0,0,-100,$FFAAAAAA));
   P00:=P1;P01:=P2;
   Floor[0]:=P2;
   Ceil[7]:=P1;
   P3:=P.AddPoint(TFacePoint.Create(100,0,0,$FFAAAAAA));
   P4:=P.AddPoint(TFacePoint.Create(100,0,-100,$FFAAAAAA));
   Floor[1]:=P4;
   Ceil[6]:=P3;
   P4.Color:=$FFFF0000;
  // P1.Color:=$FF00ff00;
   P3.Color:=$FF00ffff;


   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P1,P2,P3,P4);
  // W.Color:=$FFFFFF00;
   W.SetStripCoords(0,0,1,1);
  // W.SetNormal(NormalizePoint(Point3S(0,1,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));
   //W.SplitFace(TFace(W.Faces[1]));

   P1:=P.AddPoint(TFacePoint.Create(200,100,0,$FFAAAAAA));
   P2:=P.AddPoint(TFacePoint.Create(200,100,-100,$FFAAAAAA));
   Floor[2]:=P2;
   Ceil[5]:=P1;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P3,P4,P1,P2);
   W.SetStripCoords(0,0,1,1);
  // W.SetNormal(NormalizePoint(Point3S(-1,1,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));

   P3:=P.AddPoint(TFacePoint.Create(200,200,0,$FFAAAAAA));
   P4:=P.AddPoint(TFacePoint.Create(200,200,-100,$FFAAAAAA));
   Floor[3]:=P4;
   Ceil[4]:=P3;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P1,P2,P3,P4);
   W.SetStripCoords(0,0,1,1);
  // W.SetNormal(NormalizePoint(Point3S(-1,0,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));

   P1:=P.AddPoint(TFacePoint.Create(100,300,0,$FFAAAAAA));
   P2:=P.AddPoint(TFacePoint.Create(100,300,-100,$FFAAAAAA));
   Floor[4]:=P2;
   Ceil[3]:=P1;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P3,P4,P1,P2);
   W.SetStripCoords(0,0,1,1);
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));
 //  W.SetNormal(NormalizePoint(Point3S(-1,-1,0)));



   P3:=P.AddPoint(TFacePoint.Create(0,300,0,$FFAAAAAA));
   P4:=P.AddPoint(TFacePoint.Create(0,300,-100,$FFAAAAAA));
   Floor[5]:=P4;
   Ceil[2]:=P3;

   P3.Color:=$FFFFFF00;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P1,P2,P3,P4);
   W.SetStripCoords(0,0,1,1);
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));
  // W.SetNormal(NormalizePoint(Point3S(0,-1,0)));


   P1:=P.AddPoint(TFacePoint.Create(-100,200,0,$FFAAAAAA));
   P2:=P.AddPoint(TFacePoint.Create(-100,200,-100,$FFAAAAAA));
   Floor[6]:=P2;
   Ceil[1]:=P1;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P3,P4,P1,P2);
   W.SetStripCoords(0,0,1,1);
  // W.SetNormal(NormalizePoint(Point3S(1,-1,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));

   P3:=P.AddPoint(TFacePoint.Create(-100,100,0,$FFAAAAAA));
   P4:=P.AddPoint(TFacePoint.Create(-100,100,-100,$FFAAAAAA));
   Floor[7]:=P4;
   Ceil[0]:=P3;

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P1,P2,P3,P4);
   W.SetStripCoords(0,0,1,1);
 //  W.SetNormal(NormalizePoint(Point3S(1,0,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));
  // W.SplitFace(TFace(W.Faces[1]));

   W:=S.AddWall(TWall.Create);
   W.SetStripWall(P3,P4,P00,P01);
   W.SetStripCoords(0,0,1,1);
 //  W.SetNormal(NormalizePoint(Point3S(1,1,0)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));

   S.Texture:=TextureMgr.GetTexture('Wall.jpg');


   W:=S.AddWall(TWall.Create);
   W.SetFanWall(TFacePoint.Create(50,150,-100,$FFFFFFFF),Floor);
   W.SetFanCoords(-100,0,100,100);
   W.Texture:=TextureMgr.GetTexture('Floor.jpg');
//   W.SetNormal(NormalizePoint(Point3S(0,0,1)));
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));


   W:=S.AddWall(TWall.Create);
  W.SetFanWall(TFacePoint.Create(50,150,100,$FF444444),Ceil);
   W.SetFanCoords(-100,0,100,100);
   W.Texture:=TextureMgr.GetTexture('floor01.tga');
   for I:=0 to Divs do
   W.SplitFace(TFace(W.Faces[0]));
   //   W.SetNormal(NormalizePoint(Point3S(0,0,-1)));


   Dl:=TDynamicLight.Create(ltPoint,10000000);
   Dl.DiffuseColor:=LightColor(1000,00,250);
   Dl.AmbientColor:=LightColor(1,1,1);
   Dl.SpecularColor:=LightColor(1,1,1);
   Dl.MoveAbs(50,200,-30);
   Dl.QuadraticAttenuation:=1/100*10;
   Dl.Init;
   Scene.Add(Dl);

   Renderer.SetDWord(sdShadeMode,SHADE_GOURAUD);


   Scene.Fog.Enabled:=not true;
   Scene.Fog.Mode:=FOG_EXP;
   Scene.Fog.Color:=$FF000000;
   Scene.Fog.Density:=0.01;



    GPortal.Portal.Init;
    Graphic.ClearColor:=$FF550000;

    Fire:=TGeoQuad.Create(48,48,0,TextureMgr.GetTexture('Fire.tga'));
    Fire.Culled:=false;
    Fire.Init;

    FireH:=TBase3DObj.Create;
    FireH.MoveAbs(50,200,-30);
    FireH.Init;

    FireH.AddCHild(Fire);

 end;

// F.Draw;

if (Dl.Position.Y<20)and(Sign<0) then
 Sign:=-Sign;
if (Dl.Position.Y>280)and(Sign>0) then
 Sign:=-Sign;

Dl.MoveByAxes(0,Sign,0);
FireH.MoveByAxes(0,Sign,0);

Graphic.PushDWords;
Graphic.PushFeatures;

Renderer.SetDWord(sdSrcBlend, BLEND_ONE);
Renderer.SetDWord(sdDstBlend, BLEND_ONE);
Graphic.Disable(gfLighting);
FireH.Angle:=Point3S(Camera.Angle.X-90,Camera.Angle.Y,Camera.Angle.Z);
Fire.RotateByAxes(0,0,1);
FireH.DoDraw;

Graphic.PopFeatures([gfLighting]);
Graphic.PopDWords([sdSrcBlend,sdDstBlend]);
//S.Draw;
end;

procedure CheckInput;
var Ang:TAngle3S;
dx,dy,dz,spd:single;
    P:TPoint3S;
begin
//if InputExclusive then
  begin
    Input.Update;
    Ang := Camera.Angle;
    dx:=Input.GetMouseYRel/2;
    dz:=Input.GetMouseXRel/2;
    Ang.X :=Ang.X-dx;
    Ang.Y:=0;
    Ang.Z := Ang.Z+dz;
    Ang.X := ClampValue(Ang.X, -89, 89);
    Camera.Angle := Ang;
  end;

  if Input.IsKey(VK_ESCAPE) then
    Graphic.Window.Stop;

   Spd:=Speed/Graphic.FPS;

   OldP:=Camera.Position;

  if Input.IsKey(VK_LEFT) then
    begin


      Camera.SideStep(Spd);
   //   CheckCol;

    end;
  if Input.IsKey(VK_RIGHT) then
    begin

    Camera.SideStep(-Spd);
  //  CheckCol;
    end;
  if Input.IsKey(VK_UP) then
  begin
    //Camera.MoveByDir(Spd);
    P.x := Sin(DegToRad(180 + Camera.Angle.Z));
    P.y := Cos(DegToRad(Camera.Angle.Z));
    Camera.Position := Point3S(Camera.Position.X + P.X * (Spd),
      Camera.Position.Y + P.Y * (Spd), Camera.Position.Z);

    //  CheckCol;
  end;
  if Input.IsKey(VK_DOWN) then
  begin
    //Camera.MoveByDir(-Spd);
     P.x := Sin(DegToRad(180 + Camera.Angle.Z));
    P.y := Cos(DegToRad(Camera.Angle.Z));
    Camera.Position := Point3S(Camera.Position.X + P.X * (-Spd),
      Camera.Position.Y + P.Y * (-Spd), Camera.Position.Z);

     // CheckCol;
     end;



end;

procedure OnDraw;
begin
 CheckInput;

 RunTest;



 Renderer.SetDWord(sdFillMode,FILL_SOLID);


 Font.RenderText(5,5,Format('FPS: %f',[Graphic.FPS]));
 Font.RenderText(5,20,Graphic.ActiveRenderer.Description);


  Graphic.Window.Caption := Format('X:%f  Y:%f  Z:%f', [camera.position.x,
    camera.position.y, camera.position.z]);


  if Wrf then
  Renderer.SetDWord(sdFillMode,FILL_WIREFRAME);


end;

procedure OnMessage(var Msg: TMessage);
begin
 case Msg.Msg of
  WM_KEYDOWN:case Msg.WParam of
              VK_F3:Graphic.SetResolution(320,200,16,true);
              VK_F4:Graphic.SetResolution(320,200,32,true);
              VK_F5:Graphic.SetResolution(640,400,16,true);
              VK_F6:Graphic.SetResolution(640,400,32,true);
              VK_F7:Graphic.SetResolution(1024,768,16,true);
              VK_F8:Graphic.SetResolution(1024,768,32,true);
                     Ord('L'):
                  Lighting. Enabled:=not Lighting. Enabled;
              Ord('W'):Wrf:=not Wrf;
              VK_F11:Demotools.TakeScreenShot(Graphic.Window.Canvas.Handle,
              Graphic.Window.ClientWidth,Graphic.Window.ClientHeight);
             end;
 end;
end;


var St:string;

begin
 GGraphic.CreateGraphic();

 //TextureUseMipMaps:=false;
 INI:=TInifile.Create(ExeDir+'config.ini');
  St:=INI.ReadString('Video', 'Renderer', 'Direct3D');
 Graphic.GfxParams.Width:= INI.ReadInteger('Video','Width',800);
 Graphic.GfxParams.Height:=INI.ReadInteger('Video','Height',600);
 Graphic.GfxParams.ColorBits:=INI.ReadInteger('Video','Bits',32);
 Graphic.GfxParams.FullScreen:=INI.ReadBool('Video','FullScreen',false);


 if Upcase(st[1])='D' then
  Graphic.ChangeRenderer(Graphic.GetRenByName('D3DRenderer'),false)
  else
  Graphic.ChangeRenderer(Graphic.GetRenByName('OGLRenderer'),false) ;


 Graphic.Init;


 Lighting.Enabled:=INI.ReadBool('Video','Lighting',true);
 Lighting. Ambient:=$FF000000;


 INI.Free;

 Font:=TFont.Create;
 Font.LoadRegistered('Arial');
 Font.Height:=16;
 Font.Color:=colYellow;
 Font.Init;

 Graphic.Window.OnRunProc:=OnRun;
 Graphic.Window.OnMsgProc:=OnMessage;

 Graphic.OnDraw:=OnDraw;

 ViewPort.Perspective(45,2,1000,1.33);
 Camera.MoveAbs(50,150,-50);
 Camera.LookAt(-100,100,-50);

 Graphic.ClearColor:=$FFBBBBBB;

 P:=GPortal.Portal;

 Graphic.Window.Run;


 Graphic.Free;
end.
